#!/bin/sh
#
# libplayer configure script - (c) 2006 Benjamin Zores
#
#  (fully inspirated from ffmpeg configure script, thanks to Fabrice Bellard
#                    from omc configure script, thanks to Alexis Saettler)
#

# make sure we are running under a compatible shell
unset foo
(: ${foo%%bar}) 2>/dev/null && ! (: ${foo?}) 2>/dev/null
if test "$?" != 0; then
  if test "x$OMC_CONFIGURE_EXEC" = x; then
    OMC_CONFIGURE_EXEC=1
    export OMC_CONFIGURE_EXEC
    exec bash "$0" "$@"
    exec ksh "$0" "$@"
    exec /usr/xpg4/bin/sh "$0" "$@"
  fi
  echo "No compatible shell script interpreter found."
  exit 1
fi

show_help(){
  echo "Usage: configure [options]"
  echo "Options: [defaults in brackets after descriptions]"
  echo
  echo "Standard options:"
  echo "  --help                      print this message"
  echo "  --log[=FILE|yes|no]         log tests and output to FILE [config.log]"
  echo "  --prefix=PREFIX             install in PREFIX [$PREFIX]"
  echo "  --bindir=DIR                install bins in DIR [PREFIX/bin]"
  echo "  --libdir=DIR                install libs in DIR [PREFIX/lib]"
  echo "  --includedir=DIR            install includes in DIR [PREFIX/include]"
  echo "  --docdir=DIR                install docs in DIR [PREFIX/share/doc]"
  echo "  --mandir=DIR                man documentation DIR [PREFIX/share/man]"
  echo "  --enable-static             build static libraries [default=yes]"
  echo "  --disable-static            do not build static libraries [default=no]"
  echo "  --enable-shared             build shared libraries [default=yes]"
  echo "  --disable-shared            do not build shared libraries [default=no]"
  echo ""
  echo "Wrappers options:"
  echo "  --enable-gstreamer          build GStreamer wrapper"
  echo "  --disable-gstreamer         do not build GStreamer wrapper"
  echo "  --enable-mplayer            build MPlayer wrapper"
  echo "  --disable-mplayer           do not build MPlayer wrapper"
  echo "  --enable-vlc                build VLC wrapper"
  echo "  --disable-vlc               do not build VLC wrapper"
  echo "  --enable-xine               build xine wrapper"
  echo "  --disable-xine              do not build xine wrapper"
  echo ""
  echo "Optional features:"
  echo "  --enable-binding-python     build Python bindings"
  echo "  --enable-xlib-hack          use Xlib (can cause races, beware)"
  echo ""
  echo "Search paths:"
  echo "  --with-gstreamer-dir=DIR    check for libgstreamer installed in DIR"
  echo "  --with-vlc-dir=DIR          check for libvlc installed in DIR"
  echo "  --with-xine-dir=DIR         check for libxine installed in DIR"
  echo "  --with-xcb-dir=DIR          check for libxcb installed in DIR"
  echo "  --with-vdpau-dir=DIR        check for libvdpau installed in DIR"
  echo ""
  echo "Advanced options (experts only):"
  echo "  --disable-debug             disable debugging symbols"
  echo "  --enable-debug=LEVEL        set the debug level [$debuglevel]"
  echo "  --disable-strip             disable stripping of executables at installation"
  echo "  --disable-optimize          disable compiler optimization"
  echo "  --enable-small              optimize for size instead of speed"
  echo "  --cross-prefix=PREFIX       use PREFIX for compilation tools [$cross_prefix]"
  echo "  --cross-compile             assume a cross-compiler is used"
  echo "  --disable-x11               disable X11 support"
  echo "  --enable-pic                build position-independent code"
  echo ""
  echo "Miscellaneous:"
  echo "  --disable-logcolor          disable colorful console output on terminals"
  echo "  --enable-doc                build Doxygen documentation"
  exit 1
}

log(){
  echo "$@" >>$logfile
}

log_file(){
  log BEGIN $1
  cat -n $1 >>$logfile
  log END $1
}

echolog(){
  log "$@"
  echo "$@"
}

echologn(){
  log "$@"
  echo -n "$@"
}

clean(){
  rm -f $TMPC $TMPO $TMPE $TMPS
}

die(){
  echolog "$@"
  if enabled logging; then
    echo "See file \"$logfile\" produced by configure for more details."
  else
    echo "Rerun configure with logging enabled (do not use --log=no) for more details."
  fi
  clean
  exit 1
}

set_all(){
  value=$1
  shift
  for var in $*; do
    eval $var=$value
  done
}

enable(){
  set_all yes $*
}

enabled(){
  eval test "x\$$1" = "xyes"
}

disabled(){
  eval test "x\$$1" = "xno"
}

flags_saved(){
  (: ${SAVE_CFLAGS?}) 2>/dev/null
}

save_flags(){
  flags_saved && return
  SAVE_CFLAGS="$CFLAGS"
  SAVE_CPPFLAGS="$CPPFLAGS"
  SAVE_HOST_CFLAGS="$HOST_CFLAGS"
  SAVE_LDFLAGS="$LDFLAGS"
  SAVE_extralibs="$extralibs"
}

restore_flags(){
  CFLAGS="$SAVE_CFLAGS"
  CPPFLAGS="$SAVE_CPPFLAGS"
  HOST_CFLAGS="$SAVE_HOST_CFLAGS"
  LDFLAGS="$SAVE_LDFLAGS"
  extralibs="$SAVE_extralibs"
  unset SAVE_CFLAGS
  unset SAVE_CPPFLAGS
  unset SAVE_HOST_CFLAGS
  unset SAVE_LDFLAGS
  unset SAVE_extralibs
}

temp_cflags(){
  temp_append CFLAGS "$@"
}

temp_CPPFLAGS(){
  temp_append CPPFLAGS "$@"
}

temp_host_cflags(){
  temp_append HOST_CFLAGS "$@"
}

temp_ldflags(){
  temp_append LDFLAGS "$@"
}

temp_extralibs(){
  temp_append extralibs "$@"
}

temp_append(){
  local var
  var=$1
  shift
  save_flags
  append_var "$var" "$@"
}

append_var(){
  local var f
  var=$1
  shift
  for f in $@; do
    if eval echo \$$var | grep -qv -e "$f"; then
      test -n "$(eval echo \$$var)" && eval "$var=\"\$$var $f\"" || eval "$var=\"$f\""
    fi
  done
}

append(){
  local var
  var=$1
  shift
  flags_saved && append_var "SAVE_$var" "$@"
  append_var "$var" "$@"
}

add_cflags(){
  append CFLAGS "$@"
}

add_cppflags(){
  append CPPFLAGS "$@"
}

add_ldflags(){
  append LDFLAGS "$@"
}

add_extralibs(){
  append extralibs "$@"
}

add_pkgconfig_requires(){
  append pkgconfig_requires "$@"
}

add_pkgconfig_libs(){
  append pkgconfig_libs "$@"
}

check_cmd(){
  log "$@"
  "$@" >>$logfile 2>&1
}

check_cc(){
  log check_cc "$@"
  cat >$TMPC
  log_file $TMPC
  check_cmd $cc $CPPFLAGS $CFLAGS "$@" -c -o $TMPO $TMPC
}

check_host_cc(){
  log check_host_cc "$@"
  cat >$TMPC
  log_file $TMPC
  check_cmd $host_cc $HOST_CFLAGS "$@" -c -o $TMPO $TMPC
}

check_cpp(){
  log check_cpp "$@"
  cat >$TMPC
  log_file $TMPC
  check_cmd $cc $CPPFLAGS $CFLAGS "$@" -E -o $TMPO $TMPC
}

check_ld(){
  log check_ld "$@"
  check_cc || return
  check_cmd $cc "$@" -o $TMPE $TMPO $extralibs $LDFLAGS
}

check_host_ld(){
  log check_host_ld "$@"
  check_host_cc || return
  check_cmd $host_cc $HOST_LDFLAGS "$@" -o $TMPE $TMPO
}

check_exec(){
  check_ld "$@" && { enabled cross_compile || $TMPE >>$logfile 2>&1; }
}

check_cppflags(){
  log check_cppflags "$@"
  check_cc "$@" <<EOF && append CPPFLAGS "$@"
int x;
EOF
}

check_cflags(){
  log check_cflags "$@"
  check_cc "$@" <<EOF && add_cflags "$@"
int x;
EOF
}

check_ldflags(){
  log check_ldflags "$@"
  check_ld "$@" <<EOF && add_ldflags "$@"
int main(){
  return 0;
}
EOF
}

check_header(){
  local header
  log check_header "$@"
  header=$1
  shift
  check_cpp "$@" <<EOF
#include <$header>
int x;
EOF
}

check_func(){
  local func
  log check_func "$@"
  func=$1
  shift
  check_ld "$@" <<EOF
extern int $func();
int main(){
  $func();
  return 0;
}
EOF
}

check_lib(){
  local header func err
  log check_lib "$@"
  header="$1"
  func="$2"
  shift 2
  temp_extralibs "$@"
  check_header $header && check_func $func && add_extralibs "$@"
  err=$?
  restore_flags
  return $err
}

check_libconfig(){
  local config func ccflags clibs err
  log check_libconfig "$@"
  config="$1"
  func="$2"
  ccflags="${3:---cflags}"
  clibs="${4:---libs}"
  err=1
  if `which "$config" 1>/dev/null 2>&1`; then
    cflags=`$config $ccflags`
    [ -n "$cflags" ] && check_cflags "$cflags"
    libs=`$config $clibs`
    if [ -n "$libs" ]; then
      temp_extralibs "$libs"
      check_func $func && add_extralibs "$libs"
      err=$?
      restore_flags
    fi
  fi
  return $err
}

check_libconfig_exists(){
  local config func ccflags clibs err
  log check_libconfig_exists "$@"
  config="$1"
  func="$2"
  ccflags="${3:---cflags}"
  clibs="${4:---libs}"
  err=1
  if `which "$config" 1>/dev/null 2>&1`; then
    cflags=`$config $ccflags`
    [ -n "$cflags" ] && temp_cflags "$cflags"
    libs=`$config $clibs`
    if [ -n "$libs" ]; then
      temp_extralibs "$libs"
      check_func $func
      err=$?
      restore_flags
    fi
  fi
  return $err
}

check_pkgconfig(){
  local pkg func ccflags clibs err
  log check_pkgconfig "$@"
  pkg="$1"
  func="$2"
  ccflags="${3:---cflags}"
  clibs="${4:---libs}"
  err=1
  if `which pkg-config 1>/dev/null 2>&1`; then
    cflags=`pkg-config $pkg $ccflags`
    [ -n "$cflags" ] && check_cflags "$cflags"
    libs=`pkg-config $pkg $clibs`
    if [ -n "$libs" ]; then
      temp_extralibs "$libs"
      check_func $func
      err=$?
      restore_flags
    fi
  fi
  return $err
}

check_lib_pkgcfg(){
  local pkg header func err
  log check_lib_pkgcfg "$@"
  pkg="$1"
  header="$2"
  func="$3"
  shift 3
  err=1
  check_pkgconfig $pkg $func && add_pkgconfig_requires $pkg && err=0
  [ "$err" != 0 ] && check_lib $header $func "$@" && add_pkgconfig_libs "$@" && err=0
  return $err
}

check_lib_pkgcfg_minversion(){
  local pkg version err
  log check_lib_pkgcf_minversiong "$@"
  pkg="$1"
  version="$2"
  shift 2
  err=1
  if `which pkg-config 1>/dev/null 2>&1`; then
    pkg-config --atleast-version=$version $pkg && err=0
  fi
  return $err
}

check_lib_libcfg(){
  local config header func err
  log check_lib_pkgcfg "$@"
  config="$1"
  header="$2"
  func="$3"
  shift 3
  err=1
  check_libconfig $config $func && add_pkgconfig_libs "$@" && err=0
  [ "$err" != 0 ] && check_lib $header $func "$@" && add_pkgconfig_libs "$@" && err=0
  return $err
}

check_lib_version() {
  local min_ver toobig_ver
  min_ver="$2"
  toobig_ver="$3"
  check_cmd pkg-config --print-errors --exists "$1 >= $min_ver $1 < $toobig_ver" 2>>$logfile
  err=$?
  return $err
}

append_config(){
  echo "$@" >> $CONFIGFILE
}

pkgconfig_generate(){
  name=$1
  shortname=${name#lib}
  comment=$2
  version=$3
  libs=$4
  requires=$5
  cflags=$6

  cat <<EOF >$name.pc
PREFIX=$PREFIX
libdir=$libdir
includedir=$includedir

Name: $name
Description: $comment
Version: $version
Requires: $(enabled shared || echo $requires)
Requires.private: $(enabled shared && echo $requires)
Conflicts:
Libs: -L\${libdir} -l${shortname} $(enabled shared || echo $libs)
Libs.private: $(enabled shared && echo $libs)
Cflags: -I\${includedir} $cflags
EOF
}

add_pkgconfig_deps() {
  if `which pkg-config 1>/dev/null 2>&1`; then
    add_cflags `pkg-config "$1" --cflags 2>>$logfile`
    add_extralibs `pkg-config "$1" --libs 2>>$logfile`
  fi
}

# set temporary file name
if test ! -z "$TMPDIR" ; then
  TMPDIR1="${TMPDIR}"
elif test ! -z "$TEMPDIR" ; then
  TMPDIR1="${TEMPDIR}"
else
  TMPDIR1="/tmp"
fi

TMPC="${TMPDIR1}/libplayer-${RANDOM}-$$-${RANDOM}.c"
TMPO="${TMPDIR1}/libplayer-${RANDOM}-$$-${RANDOM}.o"
TMPE="${TMPDIR1}/libplayer-${RANDOM}-$$-${RANDOM}"
TMPS="${TMPDIR1}/libplayer-${RANDOM}-$$-${RANDOM}.S"

CONFIGFILE="config.mak"

#################################################
#   set default parameters
#################################################
logging="yes"
logfile="config.log"
PREFIX="/usr/local"
bindir='${PREFIX}/bin'
libdir='${PREFIX}/lib'
includedir='${PREFIX}/include'
docdir='${PREFIX}/share/doc'
mandir='${PREFIX}/share/man'
static="yes"
shared="yes"
cc="gcc"
host_cc="gcc"
ar="ar"
ranlib="ranlib"
make="make"
strip="strip"
arch=`uname -m`
cpu="generic"
optimize="yes"
small="no"
debug="yes"
dostrip="yes"
extralibs=""
installstrip="-s"
cross_compile="no"
wrapper_xine="auto"
wrapper_mplayer="auto"
wrapper_vlc="auto"
wrapper_gstreamer="auto"
binding_python="no"
xlib_hack="no"
vdpau="no" # depends of xlib_hack
x11="auto"
pic="no"
INSTALL="install"
VERSION=""
pkgconfig_requires=""
pkgconfig_libs=""
logcolor="yes"
doc="no"

#################################################
#   check options
#################################################
for opt do
  optval="${opt#*=}"
  case "$opt" in
  --log)
  ;;
  --log=*) logging="$optval"
  ;;
  --prefix=*) PREFIX="$optval"; force_prefix=yes
  ;;
  --bindir=*) bindir="$optval"
  ;;
  --libdir=*) libdir="$optval"; force_libdir=yes
  ;;
  --includedir=*) includedir="$optval"
  ;;
  --docdir=*) docdir="$optval"; force_docdir=yes
  ;;
  --mandir=*) mandir="$optval"
  ;;
  --enable-static) static="yes"
  ;;
  --disable-static) static="no"
  ;;
  --enable-shared) shared="yes"
  ;;
  --disable-shared) shared="no"
  ;;
  --enable-debug=*) debug="yes"; debuglevel="$optval"
  ;;
  --enable-debug) debug="yes"
  ;;
  --disable-debug) debug="no"
  ;;
  --enable-strip) dostrip="yes"
  ;;
  --disable-strip) dostrip="no"
  ;;
  --enable-optimize) optimize="yes"
  ;;
  --disable-optimize) optimize="no"
  ;;
  --enable-small) small="yes"
  ;;
  --disable-small) small="no"
  ;;
  --cross-prefix=*) cross_prefix="$optval"
  ;;
  --cross-compile) cross_compile="yes"
  ;;
  --enable-xine) wrapper_xine="yes";
  ;;
  --disable-xine) wrapper_xine="no";
  ;;
  --enable-binding-python) binding_python="yes";
  ;;
  --disable-binding-python) binding_python="no";
  ;;
  --enable-xlib-hack) xlib_hack="yes";
  ;;
  --disable-xlib-hack) xlib_hack="no";
  ;;
  --with-xine-dir=*) libxinedir="$optval";
  ;;
  --enable-mplayer) wrapper_mplayer="yes";
  ;;
  --disable-mplayer) wrapper_mplayer="no";
  ;;
  --enable-vlc) wrapper_vlc="yes";
  ;;
  --disable-vlc) wrapper_vlc="no";
  ;;
  --with-vlc-dir=*) libvlcdir="$optval";
  ;;
  --enable-gstreamer) wrapper_gstreamer="yes";
  ;;
  --disable-gstreamer) wrapper_gstreamer="no";
  ;;
  --with-gstreamer-dir=*) libgstreamerdir="$optval";
  ;;
  --with-xcb-dir=*) libxcbdir="$optval";
  ;;
  --with-vdpau-dir=*) libvdpaudir="$optval";
  ;;
  --enable-x11) x11="yes";
  ;;
  --disable-x11) x11="no";
  ;;
  --enable-pic) pic="yes";
  ;;
  --disable-pic) pic="no";
  ;;
  --enable-logcolor) logcolor="yes";
  ;;
  --disable-logcolor) logcolor="no";
  ;;
  --enable-doc) doc="yes";
  ;;
  --disable-doc) doc="no";
  ;;
  --help) show_help
  ;;
  *)
  echo "Unknown option \"$opt\"."
  echo "See $0 --help for available options."
  exit 1
  ;;
  esac
done

# Check for conflictual build options
if [ "$shared" = no -a "$static" = no ]; then
  echo "At least one library type must be built."
  echo "Specify --enable-static to build the static libraries or"
  echo "--enable-shared to build the shared libraries as well."
  exit 1
fi

if [ -n "$cross_prefix" ]; then
  cross_compile="yes"
  cc="${cross_prefix}${cc}"
  ar="${cross_prefix}${ar}"
  ranlib="${cross_prefix}${ranlib}"
  strip="${cross_prefix}${strip}"
else
  [ -n "$CC" ] && cc="$CC"
  [ -n "$AR" ] && ar="$AR"
  [ -n "$RANLIB" ] && ranlib="$RANLIB"
  [ -n "$STRIP" ] && strip="$STRIP"
fi
[ -n "$MAKE" ] && make="$MAKE"

[ -n "$HOST_CC" ] && HOST_CC="$HOST_CC"
[ -n "$HOST_CFLAGS" ] && HOST_CFLAGS="$HOST_CFLAGS"
[ -n "$HOST_LDFLAGS" ] && HOST_LDFLAGS="$HOST_LDFLAGS"

#################################################
#   set arch variable and specific cpu flags
#################################################
if enabled cross_compile; then
  arch="`$cc -dumpmachine | sed -e 's,\([^-]*\)-.*,\1,'`"
fi

case "$arch" in
  i386|i486|i586|i686|i86pc|BePC)
    arch="x86_32"
  ;;
  x86_64|amd64)
    arch="x86_32"
    canon_arch="`$cc -dumpmachine | sed -e 's,\([^-]*\)-.*,\1,'`"
    if [ x"$canon_arch" = x"x86_64" -o x"$canon_arch" = x"amd64" ]; then
      if [ -z "`echo $CFLAGS | grep -- -m32`"  ]; then
        arch="x86_64"
      fi
    fi
    spic=$shared
  ;;
# armv4l is a subset of armv5tel
  arm|armv4l|armv5tel)
    arch="armv4l"
  ;;
  alpha)
    arch="alpha"
    spic=$shared
  ;;
  "Power Macintosh"|ppc|ppc64|powerpc)
    arch="powerpc"
  ;;
  mips|mipsel|IP*)
    arch="mips"
    spic=$shared
  ;;
  mips64)
    arch="mips64"
    spic=$shared
  ;;
  sun4u|sparc64)
    arch="sparc64"
    spic=$shared
  ;;
  sparc)
    arch="sparc"
    spic=$shared
  ;;
  sh4)
    arch="sh4"
  ;;
  parisc|parisc64)
    arch="parisc"
    spic=$shared
  ;;
  s390|s390x)
    arch="s390"
  ;;
  m68k)
    arch="m68k"
  ;;
  ia64)
    arch="ia64"
    spic=$shared
  ;;
  bfin)
    arch="bfin"
  ;;
  *)
    arch="unknown"
  ;;
esac

# Add processor-specific flags
if test $cpu != "generic"; then
  case $cpu in
    601|ppc601|PowerPC601)
      add_cflags "-mcpu=601"
    ;;
    603*|ppc603*|PowerPC603*)
      add_cflags "-mcpu=603"
    ;;
    604*|ppc604*|PowerPC604*)
      add_cflags "-mcpu=604"
    ;;
    G3|g3|75*|ppc75*|PowerPC75*)
      add_cflags "-mcpu=750 -mpowerpc-gfxopt"
    ;;
    G4|g4|745*|ppc745*|PowerPC745*)
      add_cflags "-mcpu=7450 -mpowerpc-gfxopt"
    ;;
    74*|ppc74*|PowerPC74*)
      add_cflags "-mcpu=7400 -mpowerpc-gfxopt"
    ;;
    G5|g5|970|ppc970|PowerPC970|power4*|Power4*)
      add_cflags "-mcpu=970 -mpowerpc-gfxopt -mpowerpc64"
    ;;
    Cell|CELL|cell)
      add_cflags "-mcpu=cell"
    ;;
    i[3456]86|pentium|pentium-mmx|pentiumpro|pentium[23]|pentium-m|k6|k6-[23]|winchip-c6|winchip2|c3|athlon|athlon-tbird|athlon-4|athlon-[mx]p|athlon64|k8|opteron|athlon-fx|core2|pentium4|pentium4m|prescott|nocona)
      add_cflags "-march=$cpu"
    ;;
    sparc64)
      add_cflags "-mcpu=v9"
    ;;
    arm*|cortex*)
      add_cflags "-mcpu=$cpu"
    ;;
    *)
      die "WARNING: Unknown CPU \"$cpu\", ignored."
    ;;
  esac
fi

enable_pic(){
  enable pic
  add_cppflags -DPIC
  add_cflags   -fPIC
}

enabled spic && enable pic
enabled pic && enable_pic

#################################################
#   create logging file
#################################################
if test "$logging" != no; then
  enabled logging || logfile="$logging"
  echo "# $0 $@" >$logfile
  set >>$logfile
else
  logfile=/dev/null
fi

#################################################
#   compiler sanity check
#################################################
echolog "Checking for compiler available..."
check_exec <<EOF
int main(){
    return 0;
}
EOF
if test "$?" != 0; then
  echo "$cc is unable to create an executable file."
  if test -z "$cross_prefix" -a "$cross_compile" = no; then
    echo "If $cc is a cross-compiler, use the --cross-compile option."
  fi
  die "C compiler test failed."
fi

if test -n "`$cc -v 2>&1 | grep version | grep Apple`"; then
  dylib="yes"
else
  dylib="no"
fi

mingw32="no"
if test -n "`$cc -v 2>&1 | grep version | grep mingw`" \
     -o -n "`$cc -v 2>&1 | grep Target  | grep mingw`"; then
  mingw32="yes"
fi

#################################################
#   check for target specific flags
#################################################
# check for SIMD availability

# mmi only available on mips
if [ "$mmi" = "default" ]; then
  if [ "$arch" = "mips" ]; then
    mmi="yes"
  else
    mmi="no"
  fi
fi

# check if our compiler supports mmi
enabled mmi && check_cc <<EOF || mmi="no"
int main(void) {
    __asm__ ("lq \$2, 0(\$2)");
    return 0;
}
EOF

# test gcc version to see if vector builtins can be used
# currently only used on i386 for MMX builtins
check_cc -msse <<EOF && builtin_vector=yes || builtin_vector=no
#include <xmmintrin.h>
int main(void) {
#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 2)
return 0;
#else
#error no vector builtins
#endif
}
EOF

# test for mm3dnow.h
test "$arch" = "x86_64" && march=k8 || march=athlon
check_cc -march=$march <<EOF && mm3dnow=yes || mm3dnow=no
#include <mm3dnow.h>
int main(void) {
__m64 b1;
b1 = _m_pswapd(b1);
_m_femms();
return 0;
}
EOF

# ---
# big/little-endian test
check_cc <<EOF || die "endian test failed"
unsigned int endian = 'B' << 24 | 'I' << 16 | 'G' << 8 | 'E';
EOF
od -A n -t x1 $TMPO | grep -q '42 *49 *47 *45' && enable bigendian

# add some useful compiler flags if supported
check_cflags -W
check_cflags -Wall
check_cppflags -D_LARGEFILE_SOURCE
check_cppflags -D_FILE_OFFSET_BITS=64
check_cppflags -D_REENTRANT

# default extralibs
add_extralibs -lm && add_pkgconfig_libs -lm

#################################################
#   check for functions availability
#################################################

# pthread
check_lib pthread.h pthread_mutex_init -lpthread
if [ "$?" != 0 ]; then
  check_lib pthread.h pthread_mutex_init -lpthreadGC2
  [ "$?" != 0 ] && die "Error, can't find pthread_mutex_init !"
  add_pkgconfig_libs -lpthreadGC2
else
  add_pkgconfig_libs -lpthread
fi

#################################################
#   check for debug symbols
#################################################
enabled debug && add_cflags -g"$debuglevel" && add_cppflags -DHAVE_DEBUG

if enabled small; then
  check_cflags -Os
elif enabled optimize; then
  if test -n "`$cc -v 2>&1 | grep xlc`"; then
    add_cflags  "-O5"
    add_ldflags "-O5"
  else
    add_cflags "-O2"
  fi
fi

#################################################
#   check for libxine
#################################################
if test "$wrapper_xine" = "auto" -o "$wrapper_xine" = "yes"; then
  wrapper_xine="no"
  echolog "Checking for libxine ..."
  if [ -n "$libxinedir" ]; then
    check_cppflags -I$libxinedir/include
    check_ldflags -L$libxinedir/lib
  fi

  check_lib_pkgcfg libxine xine.h xine_init -lxine
  if [ "$?" = 0 ]; then
    add_cppflags -DHAVE_XINE
    wrapper_xine="yes"
  fi
fi

#################################################
#   check for mplayer
#################################################
if test "$wrapper_mplayer" = "auto"; then
  wrapper_mplayer="no"
  echolog "Checking for MPlayer ..."
  which mplayer 2>&1 > /dev/null
  if [ "$?" = 0 ]; then
    wrapper_mplayer="yes"
  fi
fi
if test "$wrapper_mplayer" = "yes"; then
  add_cppflags -DHAVE_MPLAYER
fi

#################################################
#   check for libvlc
#################################################
if test "$wrapper_vlc" = "auto" -o "$wrapper_vlc" = "yes"; then
  wrapper_vlc="no"
  echolog "Checking for libvlc ..."
  if [ -n "$libvlcdir" ]; then
    check_cppflags -I$libvlcdir/include
    check_ldflags -L$libvlcdir/lib
  fi

  check_lib_pkgcfg_minversion libvlc 1.1
  if [ "$?" = 0 ]; then
    check_lib_pkgcfg libvlc vlc/vlc.h libvlc_media_new_location -lvlc
    if [ "$?" = 0 ]; then
      add_cppflags -DHAVE_VLC
      wrapper_vlc="yes"
    fi
  fi
fi

#################################################
#   check for libgstreamer
#################################################
if test "$wrapper_gstreamer" = "auto" -o "$wrapper_gstreamer" = "yes"; then
  wrapper_gstreamer="no"
  echolog "Checking for libgstreamer ..."
  if [ -n "$libgstreamerdir" ]; then
    check_cppflags -I$libgstreamerdir/include
    check_ldflags -L$libgstreamerdir/lib
  fi

  check_lib_pkgcfg gstreamer-0.10 gst/gst.h gst_init -lgstreamer-0.10
  check_lib_pkgcfg gstreamer-interfaces-0.10 gst/interfaces/propertyprobe.h gst_property_probe_get_property -lgstinterfaces-0.10
  if [ "$?" = 0 ]; then
    add_cppflags -DHAVE_GSTREAMER
    wrapper_gstreamer="yes"
  fi
fi

#################################################
#   check for libxcb
#################################################
if test "$x11" = "auto" -o "$x11" = "yes"; then
  x11="no"
  echolog "Checking for libxcb ..."
  if [ -n "$libxcbdir" ]; then
    check_cppflags -I$libxcbdir/include
    check_ldflags -L$libxcbdir/lib
  fi

  check_lib_pkgcfg xcb xcb/xcb.h xcb_generate_id -lxcb
  if [ "$?" = 0 ]; then
    add_cppflags -DUSE_X11
    x11="yes"
  fi
fi

#################################################
#   check for Python
#################################################
if test "$binding_python" = "auto" -o "$binding_python" = "yes"; then
  binding_python="no"
  echolog "Checking for Python ..."
  check_libconfig_exists python-config _PyObject_New
  [ "$?" = 0 ] && binding_python="yes"
fi

#################################################
#   check for Xlib hack
#################################################
if test "$xlib_hack" = "auto" -o "$xlib_hack" = "yes"; then
  xlib_hack="no"
  if test "$x11" = "yes"; then
    echolog "Checking for libX11-xcb ..."

    check_lib_pkgcfg x11-xcb X11/Xlib-xcb.h xcb_generate_id -lX11-xcb -lX11 -lxcb
    if [ "$?" = 0 ]; then
      add_cppflags -DUSE_XLIB_HACK
      xlib_hack="yes"
    fi
  fi
fi

#################################################
#   check for libvdpau
#################################################
if enabled xlib_hack; then
  echolog "Checking for libvdpau ..."
  if [ -n "$libvdpaudir" ]; then
    check_cppflags -I$libvdpaudir/include
    check_ldflags -L$libvdpaudir/lib
  fi

  check_lib_pkgcfg vdpau vdpau/vdpau_x11.h vdp_device_create_x11 -lX11 -lvdpau
  if [ "$?" = 0 ]; then
    add_cppflags -DUSE_VDPAU
    vdpau=yes
  fi
fi

#################################################
#   version
#################################################
get_version(){
  local name file version
  name=$1
  file=src/$2
  eval $(grep "#define ${name}_VERSION_M" "$file" | awk '{ print $2"="$3 }')
  eval version=\$${name}_VERSION_MAJOR.\$${name}_VERSION_MINOR.\$${name}_VERSION_MICRO
  echo $version
}

VERSION=`get_version LIBPLAYER player.h`


#################################################
#   Miscellaneous
#################################################
if enabled logcolor; then
  add_cppflags -DUSE_LOGCOLOR
fi

# Doxygen
if enabled doc; then
  doc="no"
  which doxygen 2>&1 > /dev/null
  [ "$?" = 0 ] && doc="yes"
fi

# Add all extralibs provided by the pkgconfig files
[ -n "$pkgconfig_requires" ] && add_extralibs `pkg-config $pkgconfig_requires --libs`


#################################################
#   logging result
#################################################
echolog ""
echolog "libplayer: configure is OK"
echolog "  version            $VERSION"
echolog "configuration:"
echolog "  install prefix     $PREFIX"
echolog "  C compiler         $cc"
echolog "  AR                 $ar"
echolog "  RANLIB             $ranlib"
echolog "  STRIP              $strip"
echolog "  make               $make"
echolog "  Architecture       $arch ($cpu)"
echolog "  big-endian         ${bigendian-no}"
echolog "  debug symbols      $debug"
echolog "  strip symbols      $dostrip"
echolog "  optimize           $optimize"
echolog "  static             ${static}"
echolog "  shared             ${shared}"
echolog ""
echolog "  CFLAGS             $CFLAGS $CPPFLAGS"
echolog "  LDFLAGS            $LDFLAGS"
echolog "  extralibs          $extralibs"
echolog ""
echolog "built-in wrappers:"
echolog "  GStreamer:         $wrapper_gstreamer"
echolog "  MPlayer:           $wrapper_mplayer"
echolog "  VLC:               $wrapper_vlc"
echolog "  xine:              $wrapper_xine"
echolog ""
echolog "Bindings:"
echolog "  Python:            $binding_python"
echolog ""
echolog "Miscellaneous:"
echolog "  X11 support:       $x11"
echolog "  Xlib hack:         $xlib_hack"
echolog "  Documentation:     $doc"
echolog ""
if test  "$xlib_hack" = "yes"; then
  echolog "*** WARNING ***"
  echolog "The Xlib hack has been enabled. Programs using libplayer WILL have"
  echolog "races unless XInitThreads() is called before any Xlib usage."
  echolog "*** WARNING ***"
  echolog ""
else
  echolog "*** NOTE ***"
  echolog "The Xlib hack is disabled. VDPAU support will be limited to the"
  echolog "video output of MPlayer. Use --enable-xlib-hack to enable VDPAU"
  echolog "with xine and to have a full support with MPlayer."
  echolog "*** NOTE ***"
  echolog ""
fi

#################################################
#   save configs attributes
#################################################
echolog "Creating config.mak ..."

echo "# Automatically generated by configure - do not modify!" > $CONFIGFILE

append_config "PREFIX=$PREFIX"
append_config "prefix=\$(DESTDIR)\$(PREFIX)"
append_config "bindir=\$(DESTDIR)$bindir"
append_config "libdir=\$(DESTDIR)$libdir"
append_config "includedir=\$(DESTDIR)$includedir"
append_config "docdir=\$(DESTDIR)$docdir"
append_config "mandir=\$(DESTDIR)$mandir"

append_config "MAKE=$make"
append_config "CC=$cc"
append_config "AR=$ar"
append_config "RANLIB=$ranlib"
append_config "LN=ln"

append_config "BUILD_STATIC=$static"
append_config "BUILD_SHARED=$shared"
append_config "BUILD_DYLIB=$dylib"
append_config "BUILD_MINGW32=$mingw32"

append_config "VERSION=$VERSION"

if enabled dostrip; then
  append_config "STRIP=$strip"
  append_config "INSTALLSTRIP=$installstrip"
else
  append_config "STRIP=echo ignoring strip"
  append_config "INSTALLSTRIP="
fi
append_config "EXTRALIBS=$extralibs"

append_config "CFG_CPPFLAGS=$CPPFLAGS"
append_config "OPTFLAGS=$CFLAGS"
append_config "CFG_LDFLAGS=$LDFLAGS"
append_config "INSTALL=$INSTALL"

if enabled bigendian; then
  append_config "WORDS_BIGENDIAN=yes"
fi

append_config "DEBUG=$debug"
append_config "WRAPPER_XINE=$wrapper_xine"
append_config "WRAPPER_MPLAYER=$wrapper_mplayer"
append_config "WRAPPER_VLC=$wrapper_vlc"
append_config "WRAPPER_GSTREAMER=$wrapper_gstreamer"
append_config "BINDING_PYTHON=$binding_python"
append_config "X11=$x11"
append_config "XLIB_HACK=$xlib_hack"
append_config "DOC=$doc"

#################################################
#   make pkg-config files
#################################################
echolog "Creating libplayer.pc ..."

pkgconfig_generate libplayer \
                   "A multimedia A/V abstraction layer library" \
                   "$VERSION" \
                   "$pkgconfig_libs" \
                   "$pkgconfig_requires" \
                   ""

clean
exit 0
